package Simusol::Auxiliares;
use warnings;
use strict;
use Data::Dumper;
use XML::Parser;
use Text::Abbrev;
use Simusol::Ayudas;
$Data::Dumper::Indent = 1;

our $version = 0.87;

our %reffi;# hash de referencias a datos de archivos; key nombres de
     #archivo; value referencia a un hash 
our %refficompl;# hash de referencias a datos de archivos complementarios
    # de uno dado;
    # key nombres de archivo principal; value referencia a un hash  
    #que tiene como keys nombres de archivos secundarios
our ($curdirori,$diadir,$gnusdir,$outdir,$packdir,$mutuodir);
#$mutuodir se refire a como, en cada archivo especial, son nombrados los otros
#$mutuodir es '../' o '' para -noclas;solo lo define outdir_ext
our (@archivos_copiar,%donde_copiar,@subdirs_crear);
our $archmarca;
our %dirsal;
our %fechamarcas; #para los archivos de entrada
our $j_reruns = '';
our %dirsalida = (
    '' => 'cdata'
    ,'acs' => 'tmps'
    ,'cache' => 'results'
    ,'caj' => 'tests'
    ,'d' => 'tmps'
    ,'dat' => 'cdata'
    ,'dirac' => 'tmps'
    ,'eps' => 'results'
    ,'for' => 'cfunctions'
    ,'f' => 'tmps'
    ,'gnu' => 'results'
    ,'gra' => 'scripts'
    ,'ini' => 'tmps'
    ,'ls1' => 'tmps'
    ,'ls2' => 'tmps'
    ,'ls3' => 'tests'
    ,'lsg' => 'tests'
    ,'par' => 'results'
    ,'paraplot' => 'tests'
    ,'png' => 'results'
    ,'res' => 'results'
    ,'scripts'=>'scripts'
    ,'sim' => 'tmps'
    ,'simul' => 'results'
    ,'txt' => 'cdata'
   );
our (%reservdir,%reservdirg);
map($reservdir{$_} = 1, values %dirsalida);
map($dirsalida{".$_"} = $dirsalida{$_},keys %dirsalida);
our $cprojects = 'cprojects'; our $cauxes = 'cauxes';
our %dirguardar = ('nada'=>'nothing'
     ,'circuitogr'=>'noting'
     ,'circuito'=>$cprojects
     ,'compl'=>$cprojects
     ,'complementario'=>$cauxes
     ,'modelo'=>'cmodels'
     ,'elementos'=>'celements'
     ,'unidades'=>'celements'
    );
map(do{$_ ne 'nothing' and $reservdirg{$_} = 1},values %dirguardar);
our @extensiones = qw( sim caj d paraplot gra par gnu lsg ls3 cache); #son 
# las que intervienen en comparaciones
our %extension = (# extension buscada por el programa, salvo opcion
      '0' => 'dia'
    , '1' => 'dia'
    , 's' => 'd'
    , '3' => 'paraplot'
    , 'sim_renback' => 'dia'
);
# a veces se perdona el .dia
our %entrada = ('1' => ['dia']
               ,'s' => ['d','paraplot']
               ,'3' => ['paraplot','simul']
);
our %salida = ( '1' => [ qw(d caj par paraplot) ]
              , 's'=> [ qw(res sim simul)] # de los otros se ocupa el Sceptre
              , '3' => [ qw(gra gnu png eps) ]
);#ls3 y cache son especiales para todos
# para $marca igual a 3 las extensiones gnu png eps son mas complicadas
our %progr = ('simusol' => 0,'simusol.pl' => 0, 'simusol0.pl' => 0 
    ,'simusol1.pl' => 1, 'simusol_sceptre' => 's','simusol_sceptre.pl' => 's'
    ,'lolisol_sceptre.pl' => 's','lolisol3.pl'=>'3'
    , 'simusol3.pl' => 3, 'sim' => 0, 'sim1.pl' => 1, 'sim3.pl' => 3
    , 'sim_sceptre' => 's'
);
our @extens_reserv = ( 'ls1', 'ls2','ls4','GNU', 'GPI','gpi','acs','ini'
    , 'dirac', 'gra', 'gra1','gnu', 'gnu1' ,'log' 
    , 'res', 'res1','sim','sim1', 'simul', 'simul1'
    , 'caj', 'caj1','cache'
    , 'd', 'd1', 'paraplot', 'paraplot1', 'ls3', 'ls31', 'log','par','par1'
    , 'eps','png','ps','f','for'
    , 'shape', 'sheet', 'autosave','save', 'dump'
    , 'creci', 'html', 'svg'
);
BEGIN {
     use Exporter ();
     our ($VERSION,@ISA,@EXPORT,@EXPORT_OK,%EXPORT_TAGS);
     @ISA=qw(Exporter);
     @EXPORT=qw(
                &abrir_ls3_cache
                &aceptar_archivo_XML_dia
                &administrar_archivo
                &analizar_ARGV_simple
                &aprontar
                &backupear
                &base_propio_propiosin_puntoext
                &buscar_archivo &buscar_archivos_en_arbol
                &calcular_dirsal
                &comparar_todo
                &conseguir_eles_mods_unis
                &conseguir_nombres_ele_mod_uni
                &controlar_reservdirs 
                &copiar_archivos
                &crear_tmp_simusol
                &crear_subdirectorios
                &depurar_lista_archivos
                &elegir_archivo_ext
                &elegir_archivos
                &elegir_archivos_ele
                &elegir_archivos_mod
                &elegir_archivos_uni
                &elegir_s_3_archivo
                &estimar_archivo 
                &interpretar_outdir
                &interpretar_paraplot_SIMULADO
                &mensajear
                &outdir_ext
                &remover
                &seleccionar_archivo
                $curdirori $diadir $gnusdir $outdir $packdir
                $marca_Simusol 
                $ARCHIVOA $BASEARCHA $datedia
                $CLASEPRINCIPAL
                $CORTOA $CORTOASIN $PROPIOA $PROPIOASIN
                $PROPIOAGUARDAR $PROPIOASINGUARDAR
                $PRINCIPAL $PUNTOEXTA $NUMPRINCIPAL
                $j_reruns
                $version 
                *SALIDAls3 *SALIDAcache
                @archivos_copiar
                @busqueda_diagrama
                @extensiones
                $mutuodir $archmarca %dirguardar %dirsal %dirsalida
                %fechamarcas
                %dirguardar %donde_copiar 
                %no_ext     
                %unis_tiempo %factort
                %reffi %refficompl
                %reservdir %reservdirg
                )
}     
END();
# ----------------------------------------------------------------------------
# Cada programa, al comienzo borra de tmps y resuls y/o tests los archivos
# que espera producir;  produce los  resutados que necesita Sceptre sobre tmps,
#  y los no necesitados  por otros los produce en el lugar definitivo
# el ls3 se produce en tests (se va acumulando sobre tests);
# es inicializado por  simusol1.pl
# en %salida estan los posibles resultados;
# el .dia principal se copia en cprojects
our ($ARCHIVOA, $BASEARCHA, $CORTOA, $PROPIOA, $CORTOASIN, $PROPIOASIN);
our ($PUNTOEXTA, $PREA, $PRINCIPAL, $NUMPRINCIPAL, $CLASEPRINCIPAL, $datedia);
our %no_ext; # keys seran extensiones reservadas por Simusol
# Simusol no espera que con esa extension sea un diagrama simulable
# son extensiones usadas por simusol con distintos propositos para archivos
# que no serán diagramas

our $marca_Simusol = "producido por S I M U S O L";
our @busqueda_usuario = ("$ENV{HOME}/.simusol/","$ENV{HOME}/share/simusol/");
our @busqueda_sistema = ('/usr/local/share/simusol/','/usr/share/simusol/');
@busqueda_usuario = grep (-d $_,@busqueda_usuario);
@busqueda_sistema = grep (-d $_,@busqueda_sistema);
our @busqueda_diagrama;
# son directorios a partir de los cuales, en subdirectorios especiales,
# puede estar un archivo necesario
our %unis_tiempo;
abbrev \%unis_tiempo, qw(minutos horas segundos dias);
#lo anterior define un hash con key: abreviatura y value los dados;
# ejemplo: $unis{se} vale segundos; $unis{'aab'} está indefinido
our %factort = ('segundos' => 1, 'minutos' => 60, 'horas' => 3600
               ,'dias' => 86400);
our %mostrart=('segundos' => 's','minutos' => 'minutos','horas' => 'horas'
               ,'dias' => 'dias'); 
#----------------------------------------------------------------------------
sub abrir_ls3_cache{
  comfin('comA abrir_ls3_cache',@_); # estamos en outdir;
  # la apertura vale para el programa (y subrutinas) que la hizo, no 
  # para otros programas, 
  #    pero no se interrumpe por error; sólo hay aviso
  my $propiosin = $_[0]; my $coderr = '';
#  impr_debug(__LINE__.' Auxi %dirsal',Dumper \%dirsal);
  my (%nombre,%archivo,%presen);
  my %modo = ('ls3' => 0,'cache' => 0);
  foreach my $ext (qw (ls3 cache)) {
      if ($opt_hash{noclas}) {
	  $nombre{$ext} = "$propiosin.lss1";
      } else {
          $nombre{$ext} = "$propiosin.ls3";
      };
      $archivo{$ext} = "$dirsal{$ext}$nombre{$ext}";
#      impr_debug(__LINE__.' Auxi $ext',$dirsal{$ext}); 
#      impr_debug(__LINE__.' Auxi $dirsal{$ext}',$dirsal{$ext}); 
#      impr_debug(__LINE__.' Auxi $archivo{$ext}',$archivo{$ext}); 
      $presen{$ext} = "# Archivo $nombre{$ext} $marca_Simusol ";
      $modo{$ext} = 0;
      if (-e $archivo{$ext}) {
          my $contenido1 =`grep simusol1 $archivo{$ext}`;
          my $contenidos = `grep simusol_sceptre $archivo{$ext}`;
          my $contenido3 =  `grep simusol3 $archivo{$ext}`;
          if ($progr{$progname} eq '1') {
              $modo{$ext} = 0;
          } elsif ($progr{$progname}eq 's') {
              not $contenidos and $modo{$ext} = 1;
              $contenido3 and $modo{$ext} = 0;
          } elsif ($progr{$progname} eq'3') {
              not $contenido3 and $modo{$ext} = 1;
          }
      };
  };
 # impr_debug(__LINE__
 #   .' Auxi $opt_hash{noclas},$modo{ls3},$progname,%nombre'
 #      ,[$opt_hash{noclas},$modo{ls3},$progname,$nombre{ls3},$nombre{cache}]);
  if ($modo{ls3} and $modo{cache}) {
      open SALIDAls3, ">>$archivo{ls3}" or 
         die " $progname no pudo  escribir $archivo{ls3}";
          #pero ya otro escribio antes 
      open SALIDAcache, ">>$archivo{cache}" or 
         die " $progname no pudo escribir $archivo{cache}";
          #pero ya otro escribio antes 
   } else {
      open SALIDAls3,">$archivo{ls3}" or $coderr = 250;
      open SALIDAcache,">$archivo{cache}" or $coderr .= 250;
#       impr_debug(__LINE__.' Auxi $coderr',$coderr);
      $coderr and die
        " Parece que Ud. no tiene permisos para que $progname pueda crear
         uno o los dos:
              $archivo{ls3}    $archivo{cache}
         Así  no puede trabajar Simusol;
    (Controle que ha pedido, explicitamente o por defecto, un outdir adecuado";
      print SALIDAls3 "$presen{ls3}\n"; print SALIDAcache "$presen{cache}\n";
  };
  comfin('finA abrir_ls3_cache');
  return '';
}#abrir_ls3_cache
# ---------------------------------------------------------------------------
sub aceptar_archivo_XML_dia{# se usa cuando llegan directamente a simusol.pl
  #varios archivos
  #devuelve lista de archivos (nombre absoluto) que son de dia 
  comfin('comA aceptar_archivo_XML_dia',@_);
  my $archivo= $_[0];
  return '1' if $archivo =~ /~$/ or -d $archivo; 
  my $coderr = '';  
  my $p = XML::Parser->new(Style=>'Tree');
  my $doc;
  impr_debug(__LINE__.' Auxi por hacer parsefile $archivo ', $archivo);
 
  eval{$doc=$p->parsefile($archivo)};
  if ($@ ne '') { # quizas esta comprimido,que es el modo natural de Dia
      # impr_debug(__LINE__.' Auxi $@',$@);
      system "zcat $archivo >$gnusdir/llll 2>/dev/null";  
      eval{$doc=$p->parsefile("$gnusdir/llll")};
      if ($@ ne  '') {
#          print STDERR "      No es un buen archivo XML: $archivo\n";
          $coderr = 253;
      };
  }
  if (not $coderr) {
      if ($doc->[0] ne "dia:diagram") {
#          print STDERR "      No es un \"dia:diagram\": $archivo\n";
          $coderr = 252;       
      };
  };
  comfin('finA aceptar_archivo_XML_dia $coderr',$coderr);
  return $coderr,$doc;
 }#aceptar_archivo_XML_dia
# ---------------------------------------------------------------------------
sub administrar_archivo{
  # todos los archivos que participan de una ejecucion quedan copiados en
  # subdirectorios especiales de $outdir; incluso el diagrama principal,
  # en cprojects
  # si hay problema de choque de nombres .... 
  #$archivo: archivo tal como esta nombrado en el diagrama;
  # si no es absoluto,esta colgado de $diadir
  #puede ser un nombre absoluto o relativo
  #$dircopiar: directorio relativo donde se copiara 
  comfin('comA administrar_archivo',@_);
  impr_debug(__LINE__.' Auxi $outdir $diadir',"\n$outdir\n$diadir");
  my ($archivo,$dircopiar,$modo) = @_; 
  my ($archivoabs,$destinoabs,$nombrar_archivo); 
  (my $propio = $archivo) =~ /^.*\/([^\/]+)$/;
  if ($archivo =~ /^\//) {
     $archivoabs = $archivo;
  } else {
     $archivoabs = "$diadir$archivo";
  };
  if ($modo eq 'copia') {
      $destinoabs = "$outdir$dircopiar/$propio";
      impr_debug(__LINE__.' Auxi $propio,$archivoabs,$destinoabs'
        ,[$propio,$archivoabs,$destinoabs]);  
      push @archivos_copiar, $archivoabs;
      $donde_copiar{$archivoabs} = $destinoabs;
      $nombrar_archivo = "../$dircopiar/$propio";
  } else {
      $nombrar_archivo = $archivoabs;
  };
  my $coderr = ''; 
  # las menciones de archivos en .d son solo para personas
  # las menciones de archivos en .paraplot las lee tambien simusol3.pl
    impr_debug(__LINE__.' Auxi @archivos_copiar',\@archivos_copiar);
  impr_debug(__LINE__.' Auxi %donde_copiar',Dumper \%donde_copiar);
  comfin('finA administrar_archivo',$coderr,$nombrar_archivo);
  return $coderr,$nombrar_archivo;
}#administrar_archivo
# ---------------------------------------------------------------------------
sub analizar_ARGV_simple{
  impr_debug(__LINE__.' Auxi $debug',$debug);
  #lo usan simsusol_sceptre.pl y simusol3.pl
  #cambia directorio a $outdir  y determina $archdeseadosin  
  comfin('comA analizar_ARGV_simple',@_);
  my $extdeseada= $_[0];
  my ($coderr,$archdeseadosin) = ('',''); 
  my $cualprogr = $progr{$progname};
  $cualprogr !~ /[s3]/ and
     error_progr(0,__LINE__. "No corresponde llamar analizar_ARGV_simple");
  my ($quees,$base,$propio,$propiosin,$puntoext);
  if (@ARGV > 1) {
      push @MENSAJES," A $progname se le debe debe pedir un unico archivo";
  } elsif (@ARGV == 1) {
      my $arch = $ARGV[0];
      impr_debug(__LINE__.' Auxi $arch',$arch); 
     if ($arch =~ /\*/) {
         push @MENSAJES," A $progname se le debe debe pedir un unico archivo";
      } elsif ($arch =~ /[\?]/) {
          push @MENSAJES," No se espera que llegue aqui un ?";
      } else {
          #$arch debe apuntar al archivo.dia o al menos al directorio 
          #donde esta el archivo dia; o al .$extdeseado o al outdir
          ($quees,$base,$propio,$propiosin,$puntoext)
      = base_propio_propiosin_puntoext($arch,$extdeseada,__LINE__.' Auxi');
	  if ($quees ne 'b') {
              mensajear(" No encontre $arch.$extdeseada");
              if ($cualprogr eq '3') {
                  $extdeseada = 'simul';
                  ($quees,$base,$propio,$propiosin,$puntoext)
           = base_propio_propiosin_puntoext($arch,$extdeseada,__LINE__.' Auxi');
         	  if ($quees ne 'b') {
                      $coderr = 30;
                      mensajear(" Tampoco encontre $arch.$extdeseada");
                      comfin('finA analizar_ARGV_simple',$coderr);
                      return $coderr;
                  };
              };
          };  
     };
  };
 $coderr = revisar_lastdir();
  if ($coderr) {
      comfin('finA analizar_ARGV_simple',$coderr);
      return $coderr;
  };
  chdir $outdir;
  impr_debug(__LINE__.' Auxi ',"\n\n          ya cambiado a \$outdir $outdir");
  ($extdeseada = $puntoext) =~ s/\.//; 
  my (@listadeseada,$dirdeseada);
  my $PROPIOSIN = '*'; $propiosin and $PROPIOSIN = $propiosin;
  $dirdeseada = "$dirsal{$extdeseada}";
  impr_debug(__LINE__.' Auxi $dirdeseada',$dirdeseada);    
  impr_debug(__LINE__.' Auxi $extdeseada',$extdeseada);
  impr_debug(__LINE__.' Auxi $dirdeseada$PROPIOSIN.$extdeseada'
   ,"$dirdeseada$PROPIOSIN.$extdeseada");
  @listadeseada = `ls $dirdeseada$PROPIOSIN.$extdeseada 2>/dev/null`;
  if (@listadeseada != 1) {
      chomp @listadeseada;
      map(do{$_ = substr($_,length($dirdeseada)); $_ =~ s/\.$extdeseada//
          },@listadeseada); 
      $coderr = -1; 
      my $mensaje = " No hay exactamente un archivo .$extdeseada Sposible;"
        .' hay '.scalar @listadeseada .":\n     nombres sin la extension\n" 
        . join ("\n",@listadeseada)
        ."\n Mensaje al programador:   Agregue un nombre al comando\n";
      die $mensaje;
   } else {
      my $archdeseado = $listadeseada[0]; chomp $archdeseado;
      impr_debug(__LINE__.' Auxi $archdeseado',$archdeseado);    
      ($archdeseadosin = $archdeseado) =~ s/\.$extdeseada$//;
      impr_debug(__LINE__.' Auxi $archdeseadosin',$archdeseadosin);    
      ($PROPIOSIN = $archdeseadosin) =~ s/^$dirdeseada//; 
      $fechamarcas{$extdeseada} =  scalar localtime((stat $archdeseado)[9]);
  };
  comfin('finA analizar_ARGV_simple',$coderr,$dirdeseada,$PROPIOSIN);
  return $coderr,$dirdeseada,$PROPIOSIN;
}#analizar_ARGV_simple';
# ---------------------------------------------------------------------------
sub analizar_todo{
  comfin('comA analizar_todo',@_);
  my ($base,$PROPIOSIN,$cod1, $cods, $cod3) = @_;
  my $num = 1; 
  my $basearch = "$dirsal{ls3}/$PROPIOSIN";
  my $difest = '';
  ($cod1 =~/^[1345679]$/ or $cod1 == 10) and $cod1 = 0;
  # 1 para elementos, modelos, unidades; 4 para complementarios;
  # 5, 6, 9, 10  para circuito erroneo con  .d
  my %codd = ('sim'=>$cods,'caj'=> 0
                ,'d'=>$cod1,'paraplot'=>$cod1,'gra'=>$cod3,'gnu'=>$cod3
                ,'par'=>$cod1,'ls3'=>0);
  if($cod1 == 99) {
      $codd{d}= $cods;$codd{paraplot} = $cod3;
  };
  $cod1 == 2 and $codd{paraplot} = 0; 
  $cod1 =~/3|4|5|6/ and $codd{cache} = 0;
  system "rm $basearch.difes 2>/dev/null";
  foreach my $ext (@extensiones) {
      my $cod = $codd{$ext};
      my $ba_arch = "$dirsal{$ext}$PROPIOSIN";
      impr_debug(__LINE__.' Auxi $ba_arch',$ba_arch);
      if ($ext eq 'gnu') {
          my @dirgnus = conseguir_nombres_gnu($PROPIOSIN);
          @dirgnus and $ba_arch = "$dirsal{$ext}$dirgnus[0]";
      }; 
#      eco("Por mirar    $ext desde $ba_arch");
      $difest .= ' ' . compara($ba_arch, $ext, $cod);
  };
#  die if $difest=~ /v/;
  $difest .= ' ||';
  comfin('finA analizar_todo');
  return $difest;
} #analizar_todo
# ----------------------------------------------------------------------------
sub aprontar{
  # la usan simusol1.pl simusol_sceptre.pl, simusol3.pl y Auxiliares.pm
  # para determinar si se puede continuar y lo que hay que borrar o registrar
  # $punext la extension con punto buscada ( o '')
  # $propio y $clasearch los usa solo simusol1.pl
  comfin('comA aprontar',@_);
  my ($punext,$propiosin,$propio,$archivodia,$clasearch) = @_;
#  impr_debug(__LINE__.' Auxi $outdir',$outdir);
  #ya estamos en $outdir 
  my $coderr = 0;
  (my $ext = $punext) =~ s/^\.//;
# -----------------------------------------------------------------------------
#  outdir_ext(); #se saco fuera de aprontar; antes de aprontar
# -----------------------------------------------------------------------------
  my $progr = $progr{$progname};
#  impr_debug(__LINE__.' Auxi $propiosin,$progr,$ext',[$propiosin,$progr,$ext]);
  my $archparals3 = "$dirsal{ls3}$propiosin";
  my $archparacache = "$dirsal{cache}$propiosin";
  if ($progr eq 1) {
      abrir_ls3_cache($propiosin);
      mensaje_principal($archparals3,$archparacache,$clasearch);
      my $dirg = $dirguardar{$clasearch};
      $dirg and system "cp -p $archivodia $outdir$dirg/";
      print SALIDAcache "Archivo $propio copiado en $mutuodir$dirg\n";
  } elsif ($progr =~ /[s3]/) {
#      impr_debug(__LINE__.' Auxi $propiosin,$progr,$ext',[$propiosin,$progr,$ext]);
      if ($progr eq '3' and not -e "$dirsal{paraplot}propiosin".'.paraplot' and
          -e "$dirsal{simul}$propiosin".'.simul') {
          $ext = 'simul';
      };
      abrir_ls3_cache($propiosin); 
      my $dondeestoy = `pwd`; 
      $archmarca = "$dirsal{$ext}$propiosin".'.'.$ext;
      impr_debug(__LINE__.' Auxi $dondeestoy,$archmarca',[$dondeestoy,$archmarca]);
      $fechamarcas{$ext} = scalar localtime((stat $archmarca)[9]);
      impr_debug(__LINE__.' Auxi $fechamarcas{$ext}'." $ext",$fechamarcas{$ext});
      my $mensajeaper = sprintf "%-26s %-24s %-1s\n"
        ,"Mens.: $progname"
       ,"$mutuodir$dirsal{$ext}$propiosin.$ext",$fechamarcas{$ext};
      print SALIDAls3 '=-' x 2 . $mensajeaper;
  };  
  if ($coderr) {
      if ($progr eq '3') {
          mensajear ("No encontre un buen archivo .paraplot;
          Solo se produciran graficos pedidos interactivamente");
          abrir_ls3_cache($propiosin);
          $coderr = 1; 
      };
      comfin('finA aprontar',$coderr);
      return $coderr
  };
  my  $reruns
    = `grep -c RERUN.DESCRIPTION $outdir$dirsalida{d}/$propiosin.d 2>/dev/null`;
  $reruns and $reruns += 1 or $reruns = 0;
#  impr_debug(__LINE__.' Auxi $reruns',$reruns);
  remover($progr,$propiosin,$reruns) if $progr ne '0';
  comfin('finA aprontar',$coderr);
  return $coderr;
}#aprontar
#----------------------------------------------------------------------------
sub backupear{
  comfin('comA backupear',@_);
  my ($solo1,@archivos) = @_;
  my @misterios; 
  foreach my $archtob (@archivos) {
      $archtob !~ /^\// and $archtob = "$curdirori$archtob";
       my ($coderr,$base,$propio,$PROPIOSIN,$ext)
        = aprontar('dia',$archtob,'caj');
      my $n = 1;
      if ($solo1) { 
          foreach my $ext (@extensiones) {
              my $archext =  "$base/$dirsalida{$ext}/$PROPIOSIN.$ext";
              system  "rm $archext? 2>/dev/null";
	  };
      } else {
          while (-e "$base/$dirsalida{caj}/$PROPIOSIN.caj$n"){$n++};
      };
      impr_debug(__LINE__.' Auxi $n',$n);
      impr_debug(__LINE__.' Auxi @extensiones',\@extensiones);
      foreach my $ext (@extensiones) {
	  my $archext =  "$base$dirsalida{$ext}/$PROPIOSIN.$ext";
          my $archext1 = $archext .'1';
          if ($ext eq 'gnu') {
              my @dirgnus = conseguir_nombres_gnu($PROPIOSIN);
              if (@dirgnus) {
                  foreach my $arch (@dirgnus) {
                      $archext = "$base$dirsalida{$ext}/$arch.$ext"; 
                      impr_debug(__LINE__.' Auxi $archext',"\n    $archext");   
                      system  "cp -p $archext $archext$n";
                  };
              };
          };
          if (-e $archext) {
              impr_debug(__LINE__.' Auxi $archext',"\n    $archext");   
              system  "cp -p $archext $archext$n";
          } else {
              system "rm $archext$n 2>/dev/null";
          };

       };
  };
  print 'Unicamente se hizo "backup"s de archivos 
       '. join(' ',@extensiones),"\n";
  comfin('finA backupear');
  return
}#backupear
# -------------------------------------------------------------------------
sub base_propio_propiosin_puntoext{
# en el argumento no deben aparecer * ni ?
  comfin('comA b_p_p_p',@_); my $coderr = '';
  # devueve en $puntoext la extension con su punto o '';
  #  '' no tiene punto ni extension
  impr_debug(__LINE__.' Auxi $curdirori',$curdirori);
  my ($arch,$extdeseada) = @_; my $puntoextdeseada = '';my $puntoext;
  if ($extdeseada) {
      $puntoextdeseada = ".$extdeseada";
      $extdeseada =~ s/^\.//;
      impr_debug(__LINE__.' Auxi $extdeseada $dirsalida{$extdeseada}'
		 ,[$extdeseada,$dirsalida{$extdeseada}]);
  }; 
  while ($arch =~ s/(\/[^\/]+\/\.\.)\//\//) {};
  # impr_debug(__LINE__.' Auxi $arch',$arch);
  while ($arch =~ s/\/\//\//) {}; 
  # impr_debug(__LINE__.' Auxi $arch',$arch);
  while ($arch =~ s/\/(\.\/)//) {};
  # impr_debug(__LINE__.' Auxi $arch',$arch);
  $arch =~ s/^\/\.\./\/\//;
  $arch=~ s/^\/\./\/\//;
  impr_debug(__LINE__.' Auxi $arch',$arch);
  my ($quees,$base,$propio,$propiosin) = ('n','','','');
  #$quees: 'd' direct, 'a' archivo,'n' nada 
  #     'D' directorio oculto 'A' Archivo oculto
  #    $extension de archivo encontrado
  if ($arch eq '') {
      push @MENSAJES, " Nombre o directorio sin nombre"; $coderr = 60;
  } elsif ($arch eq '/' or $arch eq '.') {
      push @MENSAJES, "$arch no es apropiado";$coderr = 60; 
  } elsif ($arch =~ /^(.*\/)([^\/]+)$/) {
      $base = $1; $propio = $2;
  } else {
      $base = './'; $propio = $arch;
  };
  impr_debug(__LINE__.' Auxi $arch,$base,$propio',[$arch,$base,$propio]);
  if ($coderr) {
      mensajear(@MENSAJES);
      comfin('finA b_p_p_p',return);
      return $coderr;
  };
  if ($propio =~ /^(.*)(\.[^\.]*)$/) {
      $propiosin = $1;$puntoext = $2;
  } else {
      $propiosin = $propio;$puntoext = '';
  };
  impr_debug(__LINE__.' Auxi $propiosin,$puntoext',[$propiosin,$puntoext]);
  my $cualprogr = '';
  $progr{$progname} and $cualprogr = $progr{$progname};
  if (-d $arch) {
      $quees = 'd';
      $cualprogr =~ /[s3]/ and not $mutuodir and outdir_ext($arch,__LINE__.' Auxi');
  } elsif (-e $arch) {
      if ($puntoext eq '.dia') {  
          $quees  = 'dia';
       } else {
          $quees = 'a';
      }; 
  };
  if ($extdeseada ne '') {
      if (-e "$outdir$dirsalida{$extdeseada}/$propiosin$puntoextdeseada") {
          $quees = 'b'; $puntoext = $puntoextdeseada;
          $propio = "$propiosin$puntoext";
      };
  }; 
  comfin('finA b_p_p_p',$quees,$base,$propio,$propiosin,$puntoext); 
  return $quees,$base,$propio,$propiosin,$puntoext;
}#base_propio_propiosin_puntoext
# ---------------------------------------------------------------------------
sub buscar_archivo{
  comfin('comA buscar archivo',@_);
  my ($propio,$curdirori,$outdir,$diadir,$packdir,$subdir) = @_;
  defined $subdir or $subdir = 'data/';
  $subdir =~ /\/$/ or $subdir.= '/';
  my ($base,$coderr) = ('',''); # $base directorio en que encontro el archivo
  my @lista;
  my @busqueda = (@busqueda_usuario,@busqueda_sistema);
  map(do {push @lista,"$_$subdir/"},@busqueda);
  impr_debug(__LINE__.' Auxi @lista',"\n".join ("\n",@lista));
  my @busqueda_diagr
    = ($busqueda_diagrama[0],"$busqueda_diagrama[1]$subdir");
  if ($curdirori ne $diadir) {
      unshift(@busqueda_diagr,$curdirori,"$curdirori$subdir");
  };
  unshift @lista,@busqueda_diagr;
  impr_debug(__LINE__.' Auxi @lista',"\n".join ("\n",@lista));
  foreach my $donde (@lista) {
       if(-d $donde and -e "$donde$propio") {
           $base = $donde; last;
       };
  };
  if (not $base) {
      if ($propio ne "$PROPIOASIN.for") {
          mensajear (
          " No encontre el archivo en ninguno de los directorios previstos\n;"
          . join "\n",@lista);
      };
      $coderr = 20; 
  }; 
  comfin('finA buscar archivo',$coderr,$base);
  return $coderr,$base;
}#buscar_archivo
# ---------------------------------------------------------------------------
sub buscar_archivos_en_arbol{
  comfin('comA buscar_archivos_en_arbol',@_);
  my $reg = $_[0]; 
  my ($coderr,$juntos) = ('',''); my @dirarray;
  my $path = $opt_hash{path};
  if ($path) {
      ($coderr,$path) = compl_archivo($path,$curdirori,1,0);
      if ($coderr) {
           parary(250," No existe un directorio $path
            No se hace la busqueda de $reg"); 
      };
  } else {
      $path = $curdirori;
  };
  if ($reg =~ /\//) {
      parary(250,"No se hace la busqueda de $reg porque 
         indica barras de directorio");
  };
  not $reg =~ /\.dia$/ and $reg .= '.dia';
  impr_debug(__LINE__.' Auxi $path',$path);
  my $comando = "find . -type f -name '$reg' 2>/dev/null";
  chdir $path;
  impr_debug(__LINE__.' Auxi ',"\n\n          ya cambiado a \$path $path");
  push @dirarray, `$comando`; chomp @dirarray;
  impr_debug(__LINE__.' Auxi @dirarray',\@dirarray);
  for my $subdir (values %dirsalida,values %dirguardar) {
      @dirarray = grep (do {not $_=~ /\/$subdir\//},@dirarray); 
  };
  impr_debug_listas(__LINE__.' Auxi @dirarray',\@dirarray);
  @dirarray or parary(250," No quedaron archivos para procesar");
  map($_=~ s/^\.\///,@dirarray);
  impr_debug_listas(__LINE__.' Auxi @dirarray',\@dirarray);
  @dirarray = seleccionar_archivo(1,'dia',\@dirarray,1
   ,"Posibles archivos-diagramas (Dia) desde
        $path");
  if (@dirarray == 1 and $dirarray[0] =~ / /) {
      $juntos = 'juntos';
  }; 
  @dirarray or
      parary(250," No quedaron archivos para procesar");
  chdir $curdirori;
  impr_debug(__LINE__.' Auxi ',"\n\n     ya cambiado a \$curdirori $curdirori");
  comfin('finA buscar_archivos_en_arbol',$juntos,@dirarray);
  return $juntos,\@dirarray;
}#buscar_archivos en_arbol
# ---------------------------------------------------------------------------
sub buscar_argumento{#sin argumentos
  comfin('comA buscar_argumento',@_);
  my $propioarchsin = $_[0]; my $puntoext; my $coderr = 250;
  my (@archbuscados,@puntoextbuscadas);
  if ($progr{$progname} eq 's') {
      @archbuscados = ("$outdir$dirsal{d}$propioarchsin.d");
      @puntoextbuscadas = ('.d');
  } elsif ($progr{$progname} eq '3') {
      @archbuscados
        = ("$outdir$dirsal{paraplot}$propioarchsin.paraplot"
          , "$outdir$dirsal{simul}$propioarchsin.simul");  
      @puntoextbuscadas = ('.paraplot','.simul');
  } else {
      @archbuscados = ("$curdirori$propioarchsin.dia"
                       ,"$curdirori$propioarchsin");
      @puntoextbuscadas = ('.dia','');
  };
  impr_debug(__LINE__.' Auxi $prog{$progname},@archbuscados,@puntoextbuscadas'
    ,[$progr{$progname},'||',@archbuscados,'||',@puntoextbuscadas]);
  my $i;
  for ($i = 0; $i < @archbuscados; $i ++) {
      if (-e $archbuscados[$i]) {
          $coderr = '';$puntoext = $puntoextbuscadas[$i];last;
      };
  };
   impr_debug(__LINE__
     .' Auxi $outdir,$diadir,$propioarchsin,$puntoext'
     ,[$outdir,$diadir,$propioarchsin,$puntoext]);
  comfin('finA buscar_argumento',$coderr,$puntoext);
  return $coderr,$puntoext;
}#buscar_argumento;
# ---------------------------------------------------------------------------
sub calcular_dirsal{#sin argumentos
  comfin('comA calcular_dirsal',@_);
  my @dirext = sort keys %dirsalida;
  @dirext = grep (do{not /\./},@dirext);
  impr_debug(__LINE__.' Auxi @dirext', \@dirext);
  if (not $opt_hash{noclas}) {
      $mutuodir = "..\/";
      map (do{#print STDERR "$_ $dirsalida{$_}\n";
           $dirsal{$_} = "$dirsalida{$_}/"}
           ,@dirext);
  } else {
      $mutuodir = '';
      map (do{#print STDERR "$_ $dirsalida{$_}\n";
           $dirsal{$_} = ""},@dirext);
  };
  comfin('finA calcular_dirsal');
  return
}#calcular_dirsal
# ---------------------------------------------------------------------------
sub compara{#compara 1 de .sim .caj .d .paraplot .gnu .gra .par .lsg .ls3 .cache
#  comfin('comA compara',@_);
  my ($basearch, $ext, $cod) = @_;
  if (-e "$basearch.$ext" and $cod) {
      system  "rm $basearch.$ext\n";
  };
  my $num=1;
  if (-e "$basearch.$ext") {
      if (-e "$basearch.$ext$num") {
          my $archgnus = "$gnusdir/simusol" . '.rxt';
          if ($ext eq 'res' or $ext eq 'simul') {
              system "sed -e 's/Infinite/INF/g' <$basearch.$ext >$archgnus";
              system "sed -e 's/Nan/NAN/g' <$archgnus >$basearch.$ext";
	      system "rm $archgnus";
          };
          my @diftext;
          if ($ext eq 'ls3') {
              my $princ = "$gnusdir/simusol";
              my $arch0gnus = $princ . '.rxt';
              my $archgnus = $princ . '.ls3';
              my $arch1gnus = $princ . '.ls31';
              system "sed -e 's/=\-=\-.*//' <$basearch.ls3 >$arch0gnus";
              #system "sed -e 's/=\-=\-.*//' <$basearch.ls3 >$arch0gnus";
              system "sed -e 's/.*S I M U S O L.*//' <$arch0gnus >$archgnus";
              system "sed -e 's/=\-=\-.*//' <$basearch.ls31 >$arch0gnus";
              system "sed -e 's/.*S I M U S O L.*//' <$arch0gnus >$arch1gnus";
              @diftext = `diff -b -B $archgnus  $arch1gnus`; chomp @diftext;
              @diftext = grep /\w/,@diftext; 
# 	      impr_debug(__LINE__.' Auxi @diftext',join("\n",@diftext));
              system "rm $archgnus $arch0gnus $arch1gnus";
          } elsif ($ext =~ /sim|cache/) {
              @diftext =
              `diff $basearch.$ext  $basearch.$ext$num`;
          } else {    
              @diftext =
               `diff -b -B -i -I fecha $basearch.$ext  $basearch.$ext$num`;
          };
#          impr_debug(__LINE__.' Auxi $ext $diftext',[$ext,@diftext])); 
          if (not  @diftext) {
#              comfin('finA compara',0);
	      return '0';
          } else {   
#	      impr_debug(__LINE__.' Auxi @diftext',join("\n",@diftext));
	      my $cuantosreng =  @diftext; 
              $cuantosreng >99 and $cuantosreng = 'x'; 
#              comfin('finA compara',$cuantosreng);
              return $cuantosreng;
          };
      } else  {
#          comfin('finA compara','n');
          return 'n';
      };
  } else {
      if( not  -e "$basearch.$ext$num") {
 #         comfin('finA compara','-');
          return '-'
      } else {
  #        comfin('finA compara','v');
          return 'v';
      };
  }; 
}#compara
#----------------------------------------------------------------------------
sub comparar_todo{
  comfin('comA comparar_todo',@_);
  my ($refsim1, $refsceptre, $refsim2, $refsim3, $imprlog
    ,$refnumarch,@dirarray) = @_;
  impr_debug(__LINE__.' Auxi $refsim1',Dumper $refsim1);
  my @codigos = union_conjunto(values %$refsim1,values %$refsceptre
                 ,values %$refsim2,values %$refsim3);
  my $path;
  if ($opt_hash{path}) {
      $path = $opt_hash{path}; chomp $path; $path !~ /\/$/ and $path .= '/';
  };
  @extensiones = ('caj');
  not $opt_hash{notrad} and push @extensiones, (qw (d paraplot par));  
  not $opt_hash{nosim} and unshift @extensiones,'sim' and push @extensiones,'d';
  defined $opt_hash{graf} and $opt_hash{graf} ne 0 and
    push @extensiones,qw(paraplot gra gnu lsg);
  @extensiones = union_conjunto(@extensiones);
  push @extensiones,'ls3','cache';
  if ($imprlog) {
      open COMPLOG,">simusol_comp.log" or die " No pude abrir simusol_comp.log";
      print COMPLOG "\#$marca_Simusol\n";
      if ($path) {
          print COMPLOG "   desde $path\n";
      } else {
          print COMPLOG "   desde $curdirori\n";
      };
      my $exten = join ' .',@extensiones;
      my $textcod = 'f';
      not $opt_hash{notrad} and $textcod .= ' S1';
      not $opt_hash{nosim} and $textcod .= ' Sc'; 
      defined $opt_hash{graf} and $opt_hash{graf} ne '0' and $textcod .=' S3';
      print COMPLOG
    "e  Comparación de archivos; extensiones:  .$exten
e               'v' significa que sólo el viejo archivo existe;
e               'n' sólo el nuevo archivo existe 
e               '-' ninguno de los dos existe
e               'x' hay diferencias pero no se han contado;
e               '0' no hay diferencias esenciales 
e Cods       extensiones
$textcod |";
  };
  my $i=0;
  impr_debug(__LINE__.' Auxi $refsceptre ', $refsceptre);
  my $COMPLOGS = ''; 
  explic(" Comienzan las comparaciones");
  impr_debug(__LINE__.' Auxi @dirarray',\@dirarray);
  foreach my $arch (@dirarray) {
      my $norden = $refnumarch->{$arch};
      my $archch = $dirarray[$norden-1];
      eco("Por comparar $norden: $archch") if $imprlog;
      my $cod1 = $refsim1->{$arch};
      my $cods = $refsceptre->{$arch}; 
      my $cod3 = $refsim3->{$arch};
      my @codigos;
      not $opt_hash{notrad} and push @codigos,$cod1;
      not $opt_hash{nosim} and push @codigos,$cods;
      defined $opt_hash{graf} and $opt_hash{graf} ne 0 and 
        push @codigos,$cod3;
      map (do{$_ = sprintf("%3s",$_)},@codigos); 
      my $codigos = sprintf "g%1s |", join '',@codigos;
      impr_debug(__LINE__.' Auxi $codigos',$codigos);
#      if ($cod1 eq '99') {
#         $COMPLOGS .= "$codigos No corresponde           || $arch\n";
#         next;
#      };    
      my ($coderr,$base,$propio,$PROPIOSIN,$ext)
        = aprontar('dia',$arch,'caj');
      if (-e "$dirsal{caj}/$PROPIOSIN.caj1" or
          -e "$dirsal{caj}/$PROPIOSIN.caj") {
           my $difest
              = analizar_todo($base,$PROPIOSIN,$cod1, $cods, $cod3);
           impr_debug(__LINE__.' Auxi $difest',$difest);
           $COMPLOGS .= "$codigos Dif.gen.: $difest $norden $arch\n";
      } else {
	   $COMPLOGS
            .= "$codigos No corr.:  sin los .caj* || $norden $arch\n";
      };   
   };
  my %noext;
  $opt_hash{notrad} and do{
      $noext{caj} = 1;$noext{par} = 1;
  };
  $opt_hash{nosim} and do {
      $noext{d}= 1; $noext{sim} = 1; $noext{res} = 1;
  };
  @extensiones = grep(do{not $noext{$_}},@extensiones);
  if ($imprlog) {
      my $extencoma = join "','.",@extensiones;
      $extencoma = "'." . $extencoma . "'";      print COMPLOG "$extencoma,\n";
      print COMPLOG $COMPLOGS;
      print COMPLOG `date`; 
      close COMPLOG;
  } else {
      print $COMPLOGS;
  };
  comfin('finA comparar_todo');
  return '';
}#comparar_todo
# ----------------------------------------------------------------------------
sub conseguir_eles_mods_unis {
  # busca todos los diagramas  _ele _mod _uni accesibles para el 
  # diagrama principal
  comfin('comA conseguir_eles_mods_unis', @_);
  my ($curdirori,$diadir,$packdir) = @_;
  impr_debug(__LINE__.' Auxi $curdirori,$diadir,$packdir'
	     ,"\n$curdirori\n$diadir\n$packdir" );
  my @busqueda = ($packdir,@busqueda_usuario,@busqueda_sistema);
  my (@dir_eles_unis,@dir_mods,@todos,@eles_unis,@mods,@eles,@unis);
  push @dir_eles_unis, $curdirori;
  push @dir_eles_unis, $curdirori . 'elements/'
     if -d  $curdirori . 'elements/'and $curdirori ne $diadir;
  push @dir_eles_unis, $diadir;
  @dir_eles_unis = union_conjunto(@dir_eles_unis);
  push @dir_mods,$curdirori;
  push @dir_mods,$curdirori . 'models/'
     if -d $curdirori . 'models/' and $curdirori ne $diadir;
  push @dir_mods, $diadir;
  @dir_mods = union_conjunto(@dir_mods);
  foreach my $dir (@busqueda) {
      push @dir_eles_unis ,$dir . 'elements/' if -d $dir . 'elements/';
      push @dir_mods, $dir . 'models/' if -d $dir . 'models/';
  };
  my (%estan,%estanrep);
  foreach my $dir (@dir_eles_unis) {
     impr_debug(__LINE__.' Auxi $dir',$dir); 
     opendir TRABAJO, $dir;
      my @dirarray = readdir TRABAJO; close TRABAJO;
      foreach my $file (@dirarray) {
          next unless not -d "$dir$file";
          if ($file =~ /_ele\.dia$/) {
             if (not $estan{$file}) {
                 push @eles,"$dir$file";
                 $estan{$file} = 1;
             } else {
                 $estanrep{$file} = 1;
             }
          } elsif ($file =~ /_uni\.dia$/) {
             if (not $estan{$file}) {
                 push @unis,"$dir$file";
                 $estan{$file} = 1;
             } else {
                 $estanrep{$file} = 1;
             }
          };
      };
  };           
  foreach my $dir (@dir_mods) {
      impr_debug(__LINE__.' Auxi $dir',$dir); 
      opendir TRABAJO, $dir;
      my @dirarray = readdir TRABAJO; close TRABAJO;
      @dirarray = grep (do {not -d "$dir$_" and /\.dia$/},@dirarray);
      impr_debug(__LINE__.' Auxi @dirarray',\@dirarray);
      foreach my $file (@dirarray) {
          next unless not -d  "$dir$file";
          if ($file =~ /_mod\.dia$/) {
             if (not $estan{$file}) {
                 push @mods,"$dir$file";
                 $estan{$file} = 1;
             } else {
                 $estanrep{$file} = 1;
             }
	  };
      };
  };
#  impr_debug(__LINE__.' Auxi %estan',Dumper \%estan);
#  impr_debug(__LINE__.' Auxi %estanrep',Dumper \%estanrep);
  impr_debug(__LINE__.' Auxi @eles',"\n".join("\n",@eles));
  impr_debug(__LINE__.' Auxi @mods',"\n".join("\n",@mods));
  impr_debug(__LINE__.' Auxi @unis',"\n".join("\n",@unis));

  comfin('finA conseguir_eles_mods_unis');
  return \@eles,\@mods,\@unis;
}#conseguir_ele_mods-unis
# ----------------------------------------------------------------------------
sub conseguir_nombres_ele_mod_uni {#no se usara
  comfin('comA conseguir_nombres_ele_mod_uni', @_);
  # $ext sera ele,mod,uni
  # $mod verdadero indica que importa mayuscula/miniscula para la busqueda
  my ($ref,$nombrev,$ext,$modo) = @_; my $extra = '\w*'; 
  my $refarchivos = $Simusol::reftrabajo->{archivo}->{$ref->{ARCHIVO}};
  my $BASE = $refarchivos->{BASEARCH};
  my $largo2;
  my $case = 'i'; 
  $case = '' if $modo;
  if ($ext eq 'ele') {
      $largo2 = 'elements/';
  } elsif ($ext eq 'mod') {
      $largo2 = 'models/'; 
  } elsif ($ext eq 'uni') {
      $largo2 = 'elements/';
  };
  my $precomando = '/^$nombrev$extra\.{0,1}$ext'; my $comando;
  my $interno = "$nombrev$extra\.{0,1}$ext";
  impr_debug(__LINE__.' Auxi $interno',$interno);
  $comando = $precomando . '$/' . $case . '  or  ' 
               . $precomando . '\.dia$/' . $case;
  impr_debug(__LINE__.' Auxi $comando',$comando);
  impr_debug(__LINE__.' Auxi $nombrev $ext $largo2'
            ,[$nombrev, $ext, $largo2]);
  my (@lista,%hashpropio);
  my @listabusqueda = (@busqueda_diagrama,@busqueda_usuario,@busqueda_sistema);
  foreach my $donde (@listabusqueda) {
      -d $donde or next;
      opendir TRABAJO,"$donde$largo2";
      impr_debug(__LINE__.' Auxi $donde,$nombrev,$ext', [$donde,$nombrev,$ext]);
      my  @dirarray0 = readdir TRABAJO; closedir TRABAJO;
      impr_debug(__LINE__.' Auxi @dirarray0',\@dirarray0);
      my @dirarray1 = sort grep (do {eval($comando)},@dirarray0); #para poder comparar 
      impr_debug(__LINE__.'Auxi @dirarray1',\@dirarray1);
      foreach my $propio (@dirarray1) {
          next if -d "$donde$largo2$propio";
          if (not  $hashpropio{$propio}) {
              push @lista, "$donde$largo2$propio";
              $hashpropio{$propio} = 1;
          };
      };
  };
  explic("Busco definición de $largo2  $nombrev (mayúsc. o minúsc) en:\n"
	 . join ("\n",@lista) );
   comfin('finA conseguir_nombres_ele_mod_uni', @lista);
  return @lista;
}#conseguir_nombres_ele_mod_uni
# ----------------------------------------------------------------------------
sub conseguir_nombres_gnu{
  comfin('comA conseguir_nombres_gnu', @_);
  my $PROPIOSIN = $_[0];
  opendir ARCHgnu, "$dirsal{gnu}";my @dirgnus= readdir ARCHgnu;
  close ARCHgnu;
  my $entr = '_m_';
  @dirgnus = grep (do {s/^($PROPIOSIN$entr.*)\.gnu$/$1/} 
                  ,@dirgnus);
  impr_debug(__LINE__.' Auxi @dirgnus',\@dirgnus);
  comfin('finA conseguir_nombres_gnu');
  return @dirgnus;
};
# ---------------------------------------------------------------------------
sub controlar_reservdirs{
  comfin('comA controlar_reservdirs',@_);
  my $crear = $_[0];# $estedir con / fin
  my ($coderr,$mensaje) = ('','');
  my @reservdirs = (union_conjunto(values %dirsalida),'cprojects','cauxes');
#  impr_debug(__LINE__.' Auxi %dirsalida',Dumper \%dirsalida);
  impr_debug(__LINE__.' Auxi',[@reservdirs]);
  my $estedir = $outdir;
#  impr_debug(__LINE__.' Auxi $estedir',$estedir);
  foreach my $reservdir (@reservdirs) { 
      if ($estedir =~ /\/$reservdir\//) {
          push @MENSAJES, "   $estedir\n,       pasando por  $reservdir,
  no es buen lugar para recibir resultados; use adecuadamente la opcion outdir";
	  $coderr = 254; last;
      };
  };
  if (not $coderr and $crear) {
      ($coderr,$mensaje) = crear_subdirectorios($outdir,@reservdirs);
  };
  comfin('finA controlar_reservdirs',$coderr,$mensaje,$outdir);
  return $coderr,$mensaje;
}#controlar_reservdirs
# ---------------------------------------------------------------------------
sub copiar_archivos{
  #REVISAR si el diagrama es funciones.dia se arma lio
  comfin('comA copiar_archivos');
  my $ref = $_[0];
  my $PROPIOSIN = $ref->{PROPIOSIN};
  my $ARCHIVO = $ref->{ARCHIVO};
#  foreach my $subdir (@subdirs_crear,'cprojects') {
#      impr_debug(__LINE__.' Auxi $outdir$subdir', "$outdir$subdir");
#      next if -d "$outdir$subdir";
#      mkdir "$outdir$subdir" or
#        parary(250, " No se puede crear el directorio $subdir en $outdir");
#  };
  impr_debug(__LINE__.' Auxi $outdir',$outdir);
  system "cp -p $ARCHIVO $outdir/cprojects/ 2>/dev/null";
  open SALIDAcache, ">>$dirsal{results}$PROPIOSIN.cache" or
    die " No pude abrir $dirsal{results}$PROPIOSIN.cache"; 
  impr_debug(__LINE__.' Auxi @subdirs_crear',\@subdirs_crear);
  impr_debug(__LINE__.' Auxi @archivos_copiar',\@archivos_copiar);
  impr_debug(__LINE__.' Auxi %donde_copiar',Dumper \%donde_copiar);
  if (@archivos_copiar) {
      print SALIDAcache "Archivos auxiliares copiados:\n";
      foreach my $arch (@archivos_copiar) {
          my $destino = $donde_copiar{$arch}; 
          impr_debug(__LINE__.' Auxi $arch,$destino',[$arch,$destino]);
 #         my ($propio,$dirpropio) = ($donde_copiar{$arch},'');
 #         if ($propio =~ s/^(.*\/)([^\/]+)/$2/) {
 #             $dirpropio = $1;
 #             $dirpropio =~ s/^$outdir//;
 #         }; 
          if ($destino) {
	      system "cp -p $arch $destino";
              my $firma = `md5sum $arch`; chomp $firma;
              my $fecha = scalar localtime((stat "$arch")[9]); 
             print SALIDAcache
                "$firma\n    de fecha $fecha copiado en $destino\n"; 
           };
      };
  };
  close SALIDAcache;
  comfin('finA copiar_archivos');
}#copiar_archivos
# ---------------------------------------------------------------------------
sub crear_subdirectorios{
  comfin('comA crear_subdirectorios',@_);
  my ($desde, @subdirs) = @_;
  my $coderr = '';
  if (-e $desde and not -e $desde) {
      push @MENSAJES, 
        " Hay un archivo no directorio $desde que se ha pedido como directorio";
  } elsif (not -d $desde) {
      mkdir $desde;
      if (not -d $desde) {
	 push @MENSAJES," No existe y no se pudo crear el directorio $desde\n";
         $coderr = 253;
     };
  };
  if (not $coderr) {
      foreach my $subdir (@subdirs) {
          if (not -d "$desde/$subdir") {
              mkdir "$desde/$subdir";
              if (not -d "$desde/$subdir") {
                  push @MENSAJES
                    , " No existe y no se pudo crear el directorio $desde/$subdir\n";
              };
          };
      };
  };
  my $mensaje = textear_MENSAJES();    
  comfin('finA crear_subdirectorios',$coderr,$mensaje);
  return $coderr,$mensaje;
}#crear_subdirectorios;
# ---------------------------------------------------------------------------
sub crear_tmp_simusol{
  comfin('comA crear_tmp_simusol',@_);
  opendir TMP,"/tmp" or die "no pude abrir directorio temporario /tmp";
  my @dirdir = readdir TMP; close TMP;
  @dirdir
   = grep (do{-d "/tmp/$_" and $_ =~ s/simusol./\/tmp\/simusol./},@dirdir);
#  impr_debug(__LINE__.' Auxi @dirdir',\@dirdir);
  if (@dirdir) {
      $gnusdir = shift @dirdir;
      system "rm $gnusdir/* 2>/dev/null";
      map(do{system "rm $_/* 2>/dev/null; rmdir $_ 2>/dev/null"},@dirdir);
  } else {
      $gnusdir = `mktemp -d /tmp/simusol.XXXXXX`; chomp $gnusdir;
#      impr_debug(__LINE__.' Auxi $gnusdir',$gnusdir);
  };
  comfin('finA crear_tmp_simusol');
  return '';
}#crear_tmp_simusol
# ---------------------------------------------------------------------------
sub depurar_lista_archivos{
  comfin('comA depurar_lista_archivos',@_);
  my $dir = $_[0];
  my  %no_arc;
  my @archivos =  ('modellib.dat', 'acsave.dat', 'datasave.dat','dirac.dat'
                  , 'pgmsave.f', 'pgmsave.for', 'pri.for','no_access'); 
  map($no_ext{$_} = 1,@extens_reserv);
  map($no_arc{$_} = 1,@archivos);
  my @conblancos = grep(do {/\s\'\"/ and -e $_},@$dir);
  if (@conblancos) {
      print STDERR 
      "Simusol no trabaja bien con archivo con blancos o comillas en el nombre;
          Se descartan @conblancos\n";
  }; 
  my @buenos; 
  impr_debug(__LINE__.' Auxi $dir',$dir); 
  foreach my $file (@$dir) {
      next if -d $file;
      my $prueba =  `grep Producido.por.Simusol $file 2>/dev/null`;
      next if $prueba;
      print STDERR"                     $file\n";
     "/$file" =~ /\/(cprojects|cauxes|celements|cmodelos)\// and next;
      $file =~ /\.dia$/ and do {push @buenos,$file;next};
      $file =~ /_run$/ and next;
      my ($ext) = ($file =~ /\.([\w]+)$/);
      if ($ext) {
          next if $no_ext{$ext};
      };
      my $filedia = "$file.dia";
      -e $filedia and do {push @buenos,$filedia; next};    
      impr_debug(__LINE__.' Auxi $filedia',$filedia);
      next if $file =~ /\/\.[\w\-]/; #archivos ocultos
      next if $file =~ /~$/; #backup    
      next if -d $file or  not -s $file or not -f $file; 
      impr_debug(__LINE__.' Auxi $file',$file);
      my $propio = '';
      my $barrafile = '/' . $file;
      $barrafile =~ /\/([^\/]+)$/ and $propio = $1;
      next unless $propio;
      next if $propio =~ /^\./;
      next if $propio =~ /^\#.+\#$/; #backup del emacs
      next if $no_arc{$propio};
      impr_debug(__LINE__.' Auxi $file',$file);
      my ($coderr,$doc) = aceptar_archivo_XML_dia($file);
      not $coderr and push @buenos,$file;
  };
  impr_debug(__LINE__.' Auxi @buenos',\@buenos);
  comfin('finA depurar_lista_archivos', 'Hay '. scalar @buenos.' '
                . paraimpr3puntos(30,@buenos));
  return \@buenos; 
  comfin('fin depurar_lista_archivos');
}#depurar_lista_archivos
# ---------------------------------------------------------------------------
sub elegir_archivos{ # lo usa simusol.pl y simusol1.pl; llama ev. a depurar_ 
 #  y/o a seleccionar_archivo
  comfin('comA elegir_archivos', @_);
  my ($refpedidos,$todos) = @_;
  my $ext = 'dia'; 
  my ($coderr,$juntos) = ('','');
# --------------------------------------------------------------------------
  my @dirarray;
  my $refdirarray = \@dirarray;
# --------------------------------------------------------------------------
  my @pedidos = union_conjunto(@$refpedidos);
  impr_debug(__LINE__.' Auxi @pedidos ',\@pedidos); 
  my ($multiples, $conamp) = (1,1);
  if (@pedidos == 0) {
     @pedidos = `ls -A -B`;chomp @pedidos;
  };  
  if ($opt_hash{impr} or $opt_hash{backup} or $opt_hash{notrad}) {
      $conamp = 0;
  };
  impr_debug(__LINE__.' Auxi @pedidos ',\@pedidos);
  my %ext_usadas;
  my (@listaconblancos,@listanoastnoblancos,@archivos);
  @listaconblancos = grep(/\s/,@pedidos);
  if (@listaconblancos) { 
      print STDERR
         " Simusol no trabaja bien con nombres de archivos con blancos como
        @listaconblancos\n";
  };
  @listanoastnoblancos = grep (do{$_ !~ /\*/ and $_ !~ /\s/},@pedidos);
#  impr_debug_listas(__LINE__.' Auxi',\@pedidos,\@listanoastnoblancos);
# --------------------------------------------------------------------------
  my (%noastnoblancos); 
  if (@listanoastnoblancos == 1) {
      comfin('finA elegir_archivos linea,$coderr,@listanoastnoblancos'
           ,__LINE__,$coderr,@listanoastnoblancos,' Quedan 1 archivo');
      my $archivo = $listanoastnoblancos[0];
      my @noexisten; 
      if (not -e $archivo) {
          push @noexisten,$archivo;
          (my $archivosin = $archivo) =~ s/\.[^\.]+$//;
          if (-e $archivosin) {
              $archivo = $archivosin;
          } elsif (-e "$archivosin.dia") {
              push @noexisten, $archivosin;    
              $archivo = "$archivosin.dia";
          } else {
              push @noexisten, $archivosin,"$archivosin.dia";
          };
          @noexisten = union_conjunto(@noexisten);    
          if (@noexisten >1) {
              my @otrosdia 
              = `find $HOME -type 'f' -name '$archivosin.dia' 2>/dev/null`;
              my @otros 
               = `find $HOME -type 'f' -name '$archivosin' 2>/dev/null`;
              my $mensaje = '';
                (@otrosdia or @otros)  and
                  $mensaje 
                     = "      En otras carpetas hay:\n"
                     . join("",@otros,@otrosdia);
              die (" No existen:\n    @noexisten\n$mensaje\n");
          };
      };  
      return $coderr,$juntos,$archivo;
  } elsif (@listanoastnoblancos >  1) {
      my $reff = depurar_lista_archivos(\@listanoastnoblancos);
      @$reff = union_conjunto(@$reff);
      @archivos = seleccionar_archivo($multiples,$ext,$reff,$conamp
         ,'Posibles archivos-diagramas (Dia) ');
      impr_debug_listas(__LINE__.' Auxi \@archivos',\@archivos);
      if (@archivos == 1 and $archivos[0] =~ / /) {
         $juntos = 'juntos';
      }; 
      comfin('finA elegir_archivos'
           ,$coderr,' Quedan '. scalar @archivos .' archivos');
      return $coderr,$juntos,@archivos;
  }; 
# --------------------------------------------------------------------------
  impr_debug_listas(__LINE__
    .' Auxi @pedidos,@listanoastnoblacos,@archivos'
		    , \@pedidos,\@listanoastnoblancos,\@archivos);
  print STDERR __LINE__.' Auxi ',"archivos: \@archivos\n" if
      @archivos < 5;
  comfin('finA elegir_archivos',' Quedan '. scalar @archivos .' archivos');
  return $coderr,$juntos,@archivos;
}#elegir_archivos
# ---------------------------------------------------------------------------
sub elegir_archivos_ele{
  comfin('comA elegir_archivos_ele',@_);
  my ($refarchele,$plantilla) = @_; 
  impr_debug(__LINE__.' Auxi $refarchele',Dumper $refarchele);
  my @lista = grep (/\/$plantilla\w*\.dia$/i,@$refarchele);
  comfin('finA elegir_archivos_ele',@lista);
  return @lista;
}#elegir_archivos_ele
# ---------------------------------------------------------------------------
sub elegir_archivos_mod{
  comfin('comA elegir_archivos_ele',@_);
  my ($refarchmod,$modelo) = @_; 
  impr_debug_listas(__LINE__.' Auxi $refarchmod',$refarchmod);
  my @lista = grep (/\/$modelo\w*\.dia$/i,@$refarchmod);
  comfin('finA elegir_archivos_mod',@lista);
  return @lista;
}#elegir_archivos_mod
# ---------------------------------------------------------------------------
sub elegir_archivos_uni{
  comfin('comA elegir_archivos_uni',@_);
  my ($refarchuni,$plantilla) = @_; 
  impr_debug_listas(__LINE__.' Auxi $refarchuni', $refarchuni);
  my @lista = grep (/\/$plantilla\w*\.dia$/i,@$refarchuni);
  comfin('finA elegir_archivos_uni',@lista);
  return @lista;
}#elegir_archivos_uni
# ---------------------------------------------------------------------------
sub elegir_s_3_archivo{
  comfin('comA elegir_s_3_archivo',@_);
  my ($ext,@argus) = @_; my $coderr = 0;
  impr_debug(__LINE__.' Auxi \%dirsal',Dumper \%dirsal);
  #$ext viene con punto
  my (@argusdia,@argussindia,@argussinext,@argusext);
  map(do{s/.*~$//;s/\.\w+$//},@argus);@argussinext = grep($_,@argus);
  @argussinext = union_conjunto(@argussinext);
  impr_debug(__LINE__.' Auxi @argussinext',\@argussinext);
  foreach (@argussinext) { 
      if (-e "$_.dia") {
	  push @argusdia,"$_.dia";
      } elsif (-e "$_$ext") {
          push @argusext,"$_$ext";
      } elsif (-e $_ and not -d $_ and not /_run$/) {
          push @argussindia,$_;
      };
  };
  my ($archivo,$cualext);
  if (@argusdia == 1) {
      $archivo = $argusdia[0]; $cualext = '.dia';
  } elsif (@argusdia >1) {
      $coderr = 250;
      parary($coderr," Hay mas de un posible diagrama;
              @argusdia"); 
  } elsif (@argussindia) {
      my $refargus = depurar_lista_archivos(\@argussindia);
      @argussindia = @$refargus;
      if (@argussindia == 1) {
          $archivo = $argussindia[0]; $cualext = '';
      };
  };
  impr_debug_listas(__LINE__.' Auxi'
    ,(\@argusdia,\@argussindia,\@argusext,\@argus));
  if (@argusext == 1) {
      $archivo = $argusext[0];$cualext = "$ext";
  } elsif (@argusext > 1) {
      $coderr = 250;
      parary($coderr," Hay mas de un posible archivo de extension $ext;
              @argusext");
  } elsif (@argussindia >1) {
      $coderr = 250;
      parary($coderr," Hay mas de un posible diagrama;
              @argussindia");
  };
  comfin('finA elegir_s_3_archivo $coderr, $archivo, $cualext'
    ,$coderr,$archivo,$cualext);
  return $coderr,$archivo,$cualext;
}#elegir_s_3_archivo
# ---------------------------------------------------------------------------
sub interpretar_outdir{#ya debe estar definido $outdir; y  con @ARGV == 1
# si el $ARGV[0] no es absoluto se interpreta como referido a $curdirori
#para indicar al archvo dia (aunque puede no haber .dia y lo que interesa 
# es el .d para simusol_sceptre.pl o el .paraplot o .simul para simusol3.pl)
# lo usan todos
  comfin('comA interpretar_outdir',@_);
  my $outdirori = $outdir; my $coderr = '';
  my ($diadir,$propioarch,$propioarchsin,$resto,$outdirfinal); 
  my $arch =$ARGV[0];
  impr_debug(__LINE__.' Auxi $outdirori,$curdirori,$arch'
  ,[$outdirori,$curdirori,$arch]);
  $propioarch = "$curdirori$arch";
  impr_debug(__LINE__.' Auxi $propioarch quizas sin su extension'
	     , $propioarch);
  $propioarch =~ s/^(.*)\/([^\/]*)$/$2/ and  $diadir = $1;
  impr_debug(__LINE__.' Auxi $1,$2',[$1,$2]);
  impr_debug(__LINE__.' Auxi $diadir,$propioarch',[$diadir,$propioarch]);
  ($propioarchsin = $propioarch) =~ s/\.\w+//;
  impr_debug(__LINE__.' Auxi $coderr',$coderr);
  ($coderr,$diadir) = simpl_directory($diadir);
  impr_debug(__LINE__.' Auxi $outdirori,$diadir',[$outdirori,$diadir]);
  my $largo_outdir = length $outdirori;
  my $largo_diadir = length $diadir;
  if ($largo_diadir >= $largo_outdir) {
      my $parte = substr($diadir,0,$largo_outdir);
      if ($parte eq $curdirori) {
          $resto = substr($diadir,$largo_outdir);
          impr_debug(__LINE__.' Auxi $resto',$resto);
      } else {
          $resto = '';
      };
      impr_debug(__LINE__
        .' Auxi $outdirori,$diadir,$resto,$propioarch,$propioarchsin'
		 ,[$outdirori,$diadir,$resto,$propioarch,$propioarchsin]);
      $outdir = "$outdirori$resto";
      impr_debug(__LINE__.' Auxi $outdir',$outdir);
   };
  ($coderr,my $archbuscado,my $extbuscada) = buscar_argumento($propioarchsin);
      my $owner =  `stat -c %U $outdir`; chomp $owner;
      my $usted =  `whoami`;chomp $usted;
#      impr_debug(__LINE__.' Auxi $owner,$usted',[$owner,$usted]);
      $owner eq $usted or die "    El directorio $outdir no sirve para outdir;
          pertenece a $owner y usted es $usted\n"; 
      my $attr = `stat -c %A $outdir`;
#      impr_debug(__LINE__.' Auxi $attr',$attr);
      $attr =~ /r.x$/ or die "    El directorio $outdir no sirve para outdir;
        no tiene los permisos necesarios. 
      Proponga uno adecuado con la opcion -outdir\n";
  my (@archbuscados,@puntoextbuscadas);
  if ($progr{$progname} eq 's') {
      @archbuscados = ("$outdir$dirsal{d}$propioarchsin.d");
      @puntoextbuscadas = ('.d');
  } elsif ($progr{$progname} eq '3') {
      @archbuscados
        = ("$outdir$dirsal{paraplot}$propioarchsin.paraplot"
          , "$outdir$dirsal{simul}$propioarchsin.simul");  
      @puntoextbuscadas = ('.paraplot','.simul');
  } else {
      @archbuscados = ("$curdirori$propioarchsin.dia"
                       ,"$curdirori$propioarchsin");
      @puntoextbuscadas = ('.dia','');
  };
  impr_debug(__LINE__.' Auxi $prog{$progname},@archbuscados,@puntoextbuscadas'
    ,[$progr{$progname},'||',@archbuscados,'||',@puntoextbuscadas]);
  $coderr = 250;
  my $i;
  for ($i = 0; $i < @archbuscados; $i ++) {
      if (-e $archbuscados[$i]) {
          $coderr = '';last;
      };
  };
 
  $outdir =~ s/([^\/])$/$1\//;
  ($coderr,$outdirfinal) = simpl_directory($outdir);
  $outdirfinal and $outdir = $outdirfinal;
  comfin('finA interpretar_outdir',$outdirfinal,$propioarchsin);
  return $outdirfinal,$propioarchsin; 
}#interpretar_outdir
# ---------------------------------------------------------------------------
sub interpretar_paraplot_SIMULADO{#solo lo usa simusol3.pl?
#interpreta los renglones que describen a SIMULADO;
# devuelve un codigo de error,codigo de juntar reruns y referencias a lista de 
# $npropios,$nunis,$nmags,$nsceptres
  comfin('comA interpretar_paraplot_SIMULADO',@_); my $coderr = 0;
  my ($PROPIOSINdia,$archparaplot,$archsimul,$refres) = @_;
  impr_debug(__LINE__.' Auxi $archparaplot',$archparaplot);
  impr_debug(__LINE__.' Auxi $archsimul',$archsimul);
  impr_debug(__LINE__.' Auxi $refres',$refres);
  open ENTRADAparaplot,$archparaplot; 
  my ($archs,$nsceptres, $npropios, $nunis, $nmags, $indices) = 
       ('',[],[],[],[],[]); 
  my @renglones = <ENTRADAparaplot>; chomp @renglones;
  if ($renglones[0] =~ /simusol_sceptre/) {
      $coderr = 3; $nsceptres = $refres;
      mensajear(" Solamente gráficos interactivos");
      comfin('finA interpretar_paraplot_SIMULADO linea',__LINE__
      ,$coderr,@$npropios,' ',@$nsceptres,' '
      ,@$nunis,' ',@$nmags,' ',@$indices, $archs);
      return $coderr,$npropios,$nsceptres,$nunis,$nmags,$indices
        ,$archs;
  };
        
  @renglones = grep(s/(\W)(SIMULADO|CALCULADO)/$1SIMULADO/i,@renglones); 
  
  map(do{s/\#+.//;s/\s+$//;s/^\s+//;s/^(.+\=)/&&&&$1/;
         s/^nomostrar/&&&&nomostrar/i },
      @renglones);
  @renglones = split('&&&&',join('',@renglones));shift(@renglones);
  foreach my $renglon (@renglones) {
      my ($que1,$que2,$que3) = ($renglon =~ /(\S+)\s+(\S+)\s*\=\s*(\S.*)/);
      $que2 ne 'SIMULADO' and next;
      $que1 eq 'juntarreruns' and next;
      defined $que3 or next;
      #para que no pierda elementos '' que se transforman en ' '
      $que1 eq 'sceptrevars' and  @$nsceptres = split(/\s*,\s*/,$que3)
	  or $que1 eq 'variables' and do {
             ($coderr,@$npropios)
               = juntar_por_paren_cur(',',split(/\s*,\s*/,$que3));
	     if ($coderr) {parary($coderr)} else {$coderr = 0};
          }
         or $que1 eq 'unidades' and @$nunis = split(/\s*,\s*/,$que3)
         or $que1 eq 'magnitudes' and @$nmags = split(/\s*,\s*/,$que3)
         or $que1 eq 'indices' and @$indices = split(/\s*,\s*/,$que3)
         or $que1 eq 'archivo' and do{
             $archs = $que3; 
             impr_debug(__LINE__.' Auxi $archsimul',$archsimul);
             impr_debug(__LINE__.' Auxi $archs',$archs);
             $archs eq "../$archsimul" or do{
                mensajear(" Nombre de archivo SIMULADO inesperado:
                   ../$archsimul ne $archs");
                return 10;
             };#do
         };# do
  };#foreach $renglon
  if (not $archs) {
      return 11,[],$refres,[],[],[],'';
      # puede ser que provenga de diagrama con solo graficos
      #no es necesario preparar el archivo .simul
  };
  impr_debug(__LINE__.' Auxi $refres,$nsceptres',[@$refres,'aaa',@$nsceptres]);
  impr_debug(__LINE__.' Auxi $npropios', $npropios);
  impr_debug(__LINE__.' Auxi $nmags,$nunis',[@$nmags,'aaa',@$nunis]);
  if (@$refres != @$nsceptres) {
      mensajear("0: Inconsistencias entre $PROPIOSINdia.ls2 y .paraplot
      Se usará solo el $PROPIOSINdia.ls2"); 
      return 0,[],$refres,[],[],[],$archs;
  };
  if (@$npropios) {
      if ($nsceptres < @$npropios) {
          $coderr = 3; 
      } elsif (@$nsceptres > scalar union_conjunto(@$npropios)) { 
          $coderr = 4;
      } elsif (@$indices  and @$indices != @$npropios) {
          $coderr = 5;
      };
      if (@$indices) {
          my @indicesord = sort {$a <=> $b} @$indices;
          $indicesord[-1] != @$nsceptres and  $coderr = 6;
      };
  } else {
      mensajear("El archivo $archparaplot no tiene datos de interes para
      construir el archivo $archsimul");
      return 0,[],$nsceptres,[],[],[],$archs;
  };    
  if (not $coderr) {
      if (@$nunis != @$npropios) {
          $coderr = 7; $nunis = []; map (push (@$nunis,'??'),@$npropios); 
      };
      if (@$nmags != @$npropios) {
          $coderr = 8; $nmags = []; map (push (@$nmags,'??'),@$npropios); 
      };
  };
  impr_debug(__LINE__.' Auxi $coderr',$coderr);
  if ($coderr =~ /[3456]/) {    $coderr = 20;
      mensajear("$coderr: Inconsistencias en el archivo $PROPIOSINdia.paraplot
      Se ignora ese archivo para confeccionar elarchivo .simul");
      return $coderr;
  };   
   if ($coderr =~ /[23456789]/) {
      comfin('finA interpretar_paraplot_SIMULADO',$coderr);
      return $coderr,$npropios,$nunis,$nmags,$nsceptres,$archs;
  };
  not @$indices and @$indices = (1 .. scalar @$npropios);
  not @$nunis and map(push (@$nunis,'??'), @$npropios);
  my (%vars,%unis,%mags);
  for (my $i = 0; $i < @$indices; $i++) {
      $vars{$indices->[$i]} = $npropios->[$i]; #si repetidos, queda el ultimo
      $unis{$indices->[$i]} = $nunis->[$i];
      $mags{$indices->[$i]} = $nmags->[$i];
  };
  ($npropios,$nunis,$nmags) = ([],[],[]);
  for (my $j= 0; $j < @$refres; $j ++) {
      push @$npropios, $vars{$j+1}; push @$nunis, $unis{$j+1};
      push @$nmags, $mags{$j+1};
  };
  comfin('finA interpretar_paraplot_SIMULADO linea',__LINE__
  ,$coderr,@$npropios,' ',@$nsceptres,' ',@$nunis,' ',@$nmags,' ',@$indices, $archs);
  return $coderr,$npropios,$nsceptres,$nunis,$nmags,$indices,$archs;
}#interpretar_paraplot_SIMULADO
# ---------------------------------------------------------------------------
sub mejorar_regnombre{
  comfin('comA mejorar_regnombre',@_);
  my ($reg,$refext_usadas,$ext) = @_; my $coderr = ''; my @mejoradas;
  #aqui llega la $reg tenga o no  algun '*'; no vienen ancladas
  if ($reg =~ /^\^/ or $reg =~ /\$$/) {
      parary(250," No tiene sentido anclar el patron de busqueda $reg");
  };
  my ($elcondia,$elsinext,$elconext) = ('',$reg,'');
  if ($reg =~ /^(.*)\.(\w*)$/) {
      my ($uno,$dos) = ($1,$2);
      $dos =~ s/\d+$//; # por los archivos de backup
      if ($no_ext{$dos}) {
          $coderr = 35;
          comfin('finA mejorar_regnombre',$coderr);
          return $coderr;
      };
      if ($refext_usadas->{$dos}){
          $elsinext = $uno;
      } else {
          $elsinext = $reg;
      };
  } else {
      $elsinext = $reg;
  };
  $elcondia = "$elsinext.dia";
  $elconext = "$elsinext.$ext";
  if ($ext eq 'dia') {
      push @mejoradas, $elsinext, $elcondia; 
   } else {
       push @mejoradas, $elconext;
   };  
   impr_debug(__LINE__.' Auxi $el,$elsinext,$elcondia,$elconext '
   		 ,[$reg,$elsinext,$elcondia,$elconext]);
   comfin('finA mejorar_regnombre', 'Hay '. scalar @mejoradas.' posibles reg '
	  . paraimpr3puntos(30,@mejoradas));die "dolores";
   return $coderr,\@mejoradas;
}#mejorar_regnombre 
# --------------------------------------------------------------------------
sub mensaje_principal{
  comfin('comA mensaje_principa',@_);
  my ($archls3,$archcache,$clasearch) = @_;
  $datedia = scalar localtime((stat $ARCHIVOA)[9]);
  my $mensajeaper = sprintf "%-26s %-24s %-1s"
,"Mens.: $progname","$mutuodir$dirguardar{$clasearch}/$PROPIOA",$datedia;
  mensajear('=-' x 2 . $mensajeaper);
#  my $texto = '   '. join("   \n",@MENSAJES);
#  mensajear($texto);
  my $mensaje = textear_MENSAJES();
  mensajear($mensaje);
  comfin('finA mensaje_principal');
  return;
}#mensaje_principal
# ---------------------------------------------------------------------------
sub mensajear{
#  comfin('com mensajear',@_);
  if (@_ != 1) {
      die "mensajear no tiene 1 argumento
          @_"
  };
  my $agre = ' _ _ _ _ '; 
  if ($debug) {
     print STDERR "$agre$_[0]\n";
  } else {
      print "$agre$_[0]\n";
  };
  no warnings;
  if (tell(SALIDAls3)) {
     print SALIDAls3 "$_[0]\n"};
}#mensajear
# --------------------------------------------------------------------------
sub outdir_ext{#sin argumentos o con candidato a $outdir #No se usara
  comfin('comA outdir_ext',@_);
  my $outdir0 = $_[0];
  if (not $outdir and $outdir0) {
      $outdir = $outdir0;
  };
  impr_debug(__LINE__.' Auxi $outdir',$outdir);
  # lo llama  simusol1.pl, simusol_sceptre.pl,simusol3.pl;
  # usa $outdir o lo define
  # calcula los directorios de archivos de entrada a partir de $outdir
  # asociados a @dirext
  # (de entrada que fueron de salida anteriormente)  o de salida que interesan
  comfin('finA outdir_ext');
}#outdir_ext
# ---------------------------------------------------------------------------
sub estimar_archivo{
  comfin('comA estimar_archivo',@_);my $coderr = '';
  my ($datoin,$extdeseada1,$extdeseada2) = @_; 
  my $dirdeseada1 = $dirsalida{$extdeseada1};
  my $dirdeseada2 = $dirsalida{$extdeseada2};
  my $outdeseada1 = "$outdir$dirdeseada1/";
  my $outdeseada2 = "$outdir$dirdeseada2/";
  $opt_hash{noclas} and $outdeseada1 = $outdeseada2 = $outdir;
  my ($puntoext,$PROPIOSIN,$predir,$ultdir,$propio1,$propio2
      ,$archdeseado1,$archdeseado2);
  if ($datoin) { 
      my $datocompl = compl_archivo($datoin,$curdirori);
      if ($datocompl =~ s/(\.\w*)$//) {
          $puntoext = $1;
      };
      if ($datocompl =~ /^(.*\/)([^\/]+)\/([^\/]+)$/) {
          $predir = $1;$ultdir = $2;$PROPIOSIN = $3;
      } elsif ($datocompl =~ /^([^\/]+)\/([^\/]+)$/) {
          $predir = ''; $ultdir = $1; $PROPIOSIN = $2;
      } elsif ($datocompl =~ /^([^\/]+)$/) {
          $predir = '';$ultdir = ''; $PROPIOSIN = $1;
      };
      impr_debug(__LINE__.' Auxi $outdir,$predir,$ultdir'
        ,"\n$outdir\n$predir\n$ultdir");
  } else {
      my @posibles1 = `ls $outdeseada1*.$extdeseada1 2>/dev/null`;
      if(@posibles1 == 1) {
          $propio1 = $posibles1[0]; chomp $propio1;
      } else {
          mensajear(" No hay archivos paraplot en $outdeseada1");
          $opt_hash{graf} = 1;
          my @posibles2 =  `ls $outdeseada2*.$extdeseada2 2>/dev/null`;
          $coderr = 1;
          $propio2 = $posibles2[0]; chomp $propio2;
      };
  };
  $PROPIOSIN and do{
    $propio1 = "$PROPIOSIN.$extdeseada1";
    $propio2 = "$PROPIOSIN.$extdeseada2";
  };
  not $coderr and do {
    $archdeseado1 = "$outdeseada1$propio1";
    $archdeseado2 = "$outdeseada2$propio2";
  };
  comfin('finA estimar_archivo',$coderr,$archdeseado1,$archdeseado2);
  return $coderr,$archdeseado1,$archdeseado2;
}#estimar_archivo;
# ---------------------------------------------------------------------------
sub remover{
  # se borran los archivos que pueden ser producidos 
  # .ls3 y .cache no se borran porque se tratan especialmente
  #suponemos estar en $outdir
  comfin('comA remover',@_);
  my ($marca,$PROPIOSIN,$cuantosreruns) = @_; my $coderr = '';
#  impr_debug(__LINE__.' Auxi %salida',Dumper \%salida);
  foreach my $ext (@{$salida{$marca}}) {
      my $sal_arch = "$dirsal{$ext}$PROPIOSIN";
#      impr_debug(__LINE__.' Auxi $sal_arch.$ext',"$sal_arch.$ext");
      system "rm $sal_arch.$ext" if -e "$sal_arch.$ext";
  };
  if ($marca eq 's') {
      my @rrs;
      if ($cuantosreruns) {
          for (my $i = 1; $i < $cuantosreruns; $i++) {
              push @rrs,"_$i";
          };
          my $sal_arch = "$dirsal{res}$PROPIOSIN";
          foreach my $ext ('.res','.simul') {
              foreach my $rr (@rrs) {
                  system "rm $sal_arch$rr$ext" if -e "$sal_arch$rr$ext";
              };
          };
      };
  };
  if ($marca eq '3') {
      my ($i,$haygraf) = (1,1);
      while ($i<20 and $haygraf) {
          for my $indgraf ('','_m') {
              my $archgraf = "$PROPIOSIN$indgraf".$indgraf;
              if (-e "$dirsal{'gnu'}$archgraf.gnu") {
                  for my $ext ('.gnu','.png','.eps') {
                      system "rm $dirsal{$ext}$archgraf$ext"
                          if -e "$dirsal{$ext}$archgraf$ext";
                  };
              };
          };
          $i++;
      };
  };        
  comfin('finA remover');
  return '';
}#remover
# ---------------------------------------------------------------------------
sub revisar_lastdir{#revisa que el ultimo directorio sea admisible
  comfin('comA revisar_lastdir',@_);
#  $outdir eq ''  and $outdir = './';
  my @dires = ($curdirori,$outdir);
  impr_debug(__LINE__.' Auxi @dires',Dumper \@dires);
  my (@malos,@indices); my $coderr = '';
  for (my $i = 0; $i<2; $i++) {
      if ($dires[$i] =~ /([^\/]+)\/$/) {
          $_ = $1;
          if ($reservdirg{$_}){
	      push @malos, $_; push @indices,$i;
          };
          if (not $opt_hash{noclas}) {
              if($reservdir{$_}) {
                  push @malos, $_; push @indices,$i;
              };
          };
       };
  };
  @malos = union_conjunto(@malos);
  my @mensajes;
  if (@malos == 2) {
      push @mensajes, 
         " El directorio de partida no debe terminar con $malos[0]";
      push @mensajes, 
         " El directorio outdir no debe terminar con $malos[1]";
  } elsif (@malos == 1 and @indices == 2) {
      push @mensajes,
         " Ni el directorio de partida ni el outdir deben terminar en $malos[0]"
  } elsif (@malos == 1 and @indices == 1) {
      my $indice = $indices[0]; my $cual;
      $indice == 0 and $cual = 'de partida' or  $cual = 'outdir'; 
      push @mensajes,
         " El directorio $cual no debe terminar en $malos[0]";
  };
  if (@mensajes) {
      my $mensaje = join "\n         ",@mensajes;
      mensajear($mensaje); $coderr = 60;
  }; 
  comfin('finA revisar_lastdir',$coderr);
  return $coderr;
}#revisar_lastdir';
# ---------------------------------------------------------------------------
sub seleccionar_archivo{# seleccion por usuario
  #devuelve lista de archivos; elementos con espacios corresponden a 
  #varios archivos a procesar juntos 
  #el tercer argumento puede ser hash o array
  comfin('comA seleccionar_archivo',@_);
  my ($multiple,$ext,$refhasharch,$conamp,$premenu) = @_;
  my @dirarray;
  if ($refhasharch =~ /^HASH/) {
      @dirarray = keys %$refhasharch;
  } elsif ($refhasharch =~ /^ARRAY/) { 
      @dirarray = @$refhasharch;
  } else {
      @dirarray = ($refhasharch);
  }; 
  @dirarray <2 and return @dirarray; 
  @dirarray = sort @dirarray;
  my $ultimo = scalar @dirarray;
  my $cualtipo = 'archivos-diagramas (Dia)';
  not $multiple  and $cualtipo = "archivos procesables por $progname";
  if (not defined $premenu) {
      $premenu = " ==== Posibles $cualtipo, desde esta carpeta";
      $premenu .= "  y siguientes" if $opt_hash{buscar}; 
  };
  my $noespe = ": Respuesta no esperada; rectifique elección: ";
  my %ofrecidos;
  print "$premenu\n";
  my %numarch;
  for(my $i = 0;$i < @dirarray; $i++) {
      my $nombre = $dirarray[$i];
      printf "%3s: %1s\n", $i+1,$nombre;
      my ($nombresinext, $nombreconext) = ($nombre,$nombre);
      $nombresinext =~ s/\.$ext$//;
      if ($nombresinext eq $nombre) {$nombreconext .= ".$ext"};
      #mover_results_tests_tmps($nombresinext);
      $ofrecidos{$nombre} = $nombre;
      $ofrecidos{$nombresinext} = $nombre; 
      $ofrecidos{$nombreconext} = $nombre;
      $ofrecidos{$nombresinext.".dia"} = $nombre;
      $ofrecidos{$i+1} = $nombre;
      $numarch{$nombreconext} = $i+1;
      $numarch{$nombresinext} = $i+1; 
  };
  #impr_debug(__LINE__.' Auxi %ofrecidos ',Dumper \%ofrecidos);
  my $ampersand = '&';# lo uso en sim_subear_usr
  if (not $multiple) {
      print '
   Indique número del archivo a procesar (o su nombre): ';
  } else {
      if ($conamp) {#solo se da junto con $multiple
          print '
  Indique número o nombre de los archivos que interesen;
      separados por '.$ampersand.' si deben procesarse juntos (mod o ele);
      separados por "," si deben procesarse por separado;
      "0": ninguno; "*": todos de a uno; 
         n1..n2  : todos de a uno entre entre n1 y n2)
            número(s) o nombre(s): ';
      } else {
         print '
  Indique números o nombres de los archivos que interese;
      (números separados por ",");
      "0": ninguno; "*"; todos de a uno; 
         n1..n2  : todos de a uno entre entre n1 y n2)
            número(s) o nombre(s): ';
      };
  };
  my (@listaplana,@listaconamp,$nombresmal);
  my $bien = 1;
  while (0 == 0)  {
      (@listaplana,@listaconamp) = (); $nombresmal = '';
      my $ilistita = <STDIN>; chomp $ilistita;       
      if ($ilistita =~ /^\s*\*\s*$/) {
          @listaplana = @dirarray; 
          last;
      };
      $ilistita =~ s/\s*\.\.\s*/\.\./g;
      $ilistita =~ s/\s*\&\s*/\&/g;
      $ilistita =~ s/^\s*//; 
      $ilistita =~ s/\s*$//;
      # los espacios que quedan se cambian a coma:
      my $ilistitacoma = $ilistita; $ilistitacoma =~ s/\s+/\,/g; 
      my @listachunk = split /\,+/,$ilistitacoma;
      impr_debug(__LINE__.' Auxi @listachunk',\@listachunk);
      foreach my $chunk (@listachunk) { 
          #impr_debug(__LINE__.' Auxi ',$chunk);
          if ($chunk =~ /\.\./) {
              #impr_debug(__LINE__.' Auxi ',$chunk);
              if ($chunk =~ /^(.+)\.\.(.+)$/) {
                  #impr_debug(__LINE__.' Auxi ',[$chunk,$1,$2]);
                  my $pri = $1; my $ult = $2;
                  $pri = $numarch{$ofrecidos{$pri}};
                  $ult = $numarch{$ofrecidos{$ult}};
                  if ($pri <= $ult and $pri >0 and $ult <= @dirarray) { 
                      push @listaplana, ($pri .. $ult);
                      next; 
                  };
              };
              $nombresmal = '***';next
          } elsif ($chunk =~ /\&/) { 
              push @listaconamp, split '&', $chunk; next;
          } else {
              push @listaplana, $chunk;
          };
      };#foreach
      impr_debug(__LINE__.' Auxi @listaplana ','Hay '. scalar @listaplana);
      @listaplana = union_conorden(@listaplana);
      @listaconamp = union_conorden(@listaconamp);
      foreach my $nom (@listaplana) {
          $nom eq '0' and do {
              comfin('finA seleccionar_archivo',());
              return ();
          };
          if (not defined $ofrecidos{$nom}) {
              $nombresmal = '***';
          } else {
              $nom =$ofrecidos{$nom};
          };
      }; #foreach
      #impr_debug(__LINE__.' Auxi @listaplana ',\@listaplana); 
      if (@listaconamp and not $conamp or
          @listaconamp and @listaplana) {
          print "\"$ilistita\"$noespe"; next;
      } elsif ($conamp) {
          foreach  my $nom (@listaconamp) {
              if (not defined $ofrecidos{$nom}) {
                  $nombresmal = '***';
              } else {
                  $nom = $ofrecidos{$nom};
              };
          }; #foreach
      };#elsif $conamp  
      $nombresmal eq '***' and do{
          print "\"$ilistita\"$noespe"; next;
      };
      push (@listaplana, join (' ', @listaconamp)) if @listaconamp;
      last;
  }; #while 0==0 
  $ext ne 'dia' and map (s/\.$ext//,@listaplana);
  comfin('finA seleccionar_archivo',@listaplana);
  return @listaplana;
}#seleccionar_archivo
#----------------------------------------------------------------------------
1
